/*
 * Copyright 2014 CyberVision, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.kaaproject.kaa.demo.playerdemo.command;

import java.util.Map;

import org.kaaproject.kaa.demo.player.DeviceInfoRequest;
import org.kaaproject.kaa.demo.player.DeviceInfoResponse;
import org.kaaproject.kaa.demo.player.PlayerClassFamily;
import org.kaaproject.kaa.demo.playerdemo.concurrent.BlockingCallable;

/** Implementation of get device info command.
 */
public class GetDeviceInfoCommand extends AbstractPlayerCommand<DeviceInfoResponse> {

    public GetDeviceInfoCommand(Map<EndpointCommandKey, BlockingCallable<?>> commandMap,
            PlayerClassFamily players, String endpontKey) {
        super(commandMap, players, endpontKey, DeviceInfoResponse.class);
    }

    @Override
    protected void executePlayerCommand() {
        DeviceInfoRequest request = new DeviceInfoRequest();
        players.sendEvent(request, endpontKey);
    }
}